// Binary Tree Header...
template <class T>
class TreeNode {
  public:
    T *data;
    TreeNode<T> *left;
    TreeNode<T> *right;
    TreeNode() { left=right=NULL; };
    TreeNode(const T &item) { // constructor
        data=new T(item);
        left=right=NULL;
    }
};

template <class T>
class BinTreeClass {
  private:
     TreeNode<T> *root;
     void InsertItemHelper(TreeNode<T> *r, TreeNode<T> *ToBeInserted) {
          if (*(r->data) > *(ToBeInserted->data)) {
             if (r->left == NULL) { r->left = ToBeInserted; return; }
             else InsertItemHelper(r->left,ToBeInserted);
         }
         else {
             if (r->right == NULL) { r->right = ToBeInserted; return; }
             else InsertItemHelper(r->right,ToBeInserted); 
         }
      }

   public:
     BinTreeClass() { root=NULL;}
     BinTreeClass(T item) {
         root = new TreeNode<T>(item);
     }
     int CountNodes() { return CountNodesHelper(root); }
     int CountNodesHelper(TreeNode<T> *cur) {
         if (cur==NULL)
		 return 0;
         else
	 	return 1+CountNodesHelper(cur->left)+CountNodesHelper(cur->right);
	 }
      int Depth() { return DepthHelper(root); }
      int DepthHelper(TreeNode<T> *r) {
	  if (r==NULL) return 0;
	  else {
	      if (DepthHelper(r->left) > DepthHelper(r->right))
	          return 1+DepthHelper(r->left);
              else
	          return 1+DepthHelper(r->right);

               }
      } 
      
     void Insert(T item) {
         TreeNode<T> *temp = new TreeNode<T>(item);
         if (root == NULL) { root = temp; return; }
         else InsertItemHelper(root,temp);
     }
     int find (char *s, Student *array[]) {
	 int count = 0;    
         findhelper(s,root,array,count);
	 return count;
     }
     void findhelper(char *s, TreeNode<T> *foo, Student *array[], int &count) {
	 if (!strcmp(foo->data->getname(),s)) {
              if(count < 20) {
		  array[count] = new Student;
                  *array[count] = *(foo->data);
 	      }
	      count++;
         }
	 if (strcmp(foo->data->getname(),s)>0 && foo->left)
		 findhelper(s,foo->left,array,count);
	 else	
		if (foo->right)
	 		findhelper(s,foo->right,array,count);
     }
     void FirstTen() { int count = 0; FirstTenHelper(root,count); }
     void FirstTenHelper(TreeNode<T> *r, int &count) {
     	if (count < 10) { cout << *(r->data) << '\t'; }
	count ++;
	if (r->left)
	       FirstTenHelper(r->left,count);
	if (r->right)
	       FirstTenHelper(r->right,count);
     }
     ~BinTreeClass() { destroy(root); }
     void destroy(TreeNode<T> *r){
     	if(r) {
		destroy(r->left);
		destroy(r->right);
		delete r;
	}
     }

};
