// hirestimer.h
class HighResTimer {
protected:
        unsigned int startTime;
        char id[30];

public:
        HighResTimer(const char* id);
        ~HighResTimer() {}

        void Start();
        unsigned int ElapsedTime();
        virtual unsigned int GetTime() = 0;
        virtual unsigned int TicksPerSecond() = 0;
};


HighResTimer::HighResTimer(const char *id)
{
        startTime = 0;
        strncpy(this->id, id, 30);
        this->id[29] = 0;
}

void HighResTimer::Start()
{
        startTime = GetTime();
}


unsigned int HighResTimer::ElapsedTime()
{
        return GetTime() - startTime;
}
